package org.ten60.netkernel.security.endpoint;

import java.security.DigestOutputStream;
import java.security.MessageDigest;
import java.util.HashMap;
import java.util.Map;

import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.representation.IBinaryStreamRepresentation;
import org.netkernel.layer0.util.NullOutputStream;
import org.netkernel.layer0.util.Utils;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;

public class CryptoCheckSumAccessor extends StandardAccessorImpl
{	
	private static Map<String, String> mAlgorithms=new HashMap<String, String>();
	
	{
		mAlgorithms.put("md5sum", "MD5");
		mAlgorithms.put("md2sum", "MD2");
		mAlgorithms.put("sha1sum", "SHA-1");
		mAlgorithms.put("sha256sum", "SHA-256");
		mAlgorithms.put("sha384sum", "SHA-384");
		mAlgorithms.put("sha512sum", "SHA-512");
		mAlgorithms.put("md2", "MD2");
		mAlgorithms.put("md5", "MD5");
		mAlgorithms.put("sha1", "SHA-1");
		mAlgorithms.put("sha256", "SHA-256");
		mAlgorithms.put("sha384", "SHA-384");
		mAlgorithms.put("sha512", "SHA-512");
	}
	
	public CryptoCheckSumAccessor()
	{	this.declareThreadSafe();
	}

	@Override
	public void onSource(INKFRequestContext context) throws Exception
	{	String type=context.getThisRequest().getArgumentValue("activeType");
		MessageDigest md = MessageDigest.getInstance(mAlgorithms.get(type));
		IBinaryStreamRepresentation bsr=context.source("arg:operand", IBinaryStreamRepresentation.class);
		DigestOutputStream dos=new DigestOutputStream(new NullOutputStream(), md);
		bsr.write(dos);
		dos.flush();
		context.createResponseFrom(Utils.toHexString(md.digest()));
	}
}
