package org.ten60.netkernel.security.representation;

import java.util.*;
import java.util.regex.*;
import java.net.*;

/**
 *	GateKeeper Zone object - stores matches, valid and invalid URI targets.
 *	Performs URI test.
 * @author  pjr
 */
public class GateKeeperZone
{
	private ArrayList mMatches;
	private String mValid;
	private String mNotValid;

	/** Create a new zone defaulting to permit on positive match*/
	public GateKeeperZone()
	{	mMatches=new ArrayList(10);
	}
	
	public void addMatch(String aMatch)
	{	Pattern p=Pattern.compile(aMatch);
		mMatches.add(p);
	}

	/** Test the URI against the set of match patterns */
	public boolean matches(String aURI)
	{	Iterator i=mMatches.iterator();
		boolean matches=false;
		while(i.hasNext())
		{	Pattern p=(Pattern)i.next();
			Matcher m=p.matcher(aURI);
			if(m.matches())
			{	matches=true;
				break;
			}
		}
		return matches;
	}

	public void setValidURI(String aURI)
	{	mValid=aURI;
	}

	public String getValidURI()
	{	return mValid;
	}

	public String getNotValidURI()
	{	return mNotValid;
	}

	public void setNotValidURI(String aURI)
	{	mNotValid=aURI;
	}
	
}
